/*---- define -------------------------------------------------*/

#define  VERSION     "v1.0"

/////////////////////////////////////////////////////////////////

#define  ON    1
#define  OFF   0
#define  YES   1
#define  NO    0


/////////////////////////////////////////////////////////////////

#define  NET_ADR_MASTER       0        //  
#define  NET_ADR_BROADCAST    127      // ப 

#define  NET_DLE              0xFA     // Data Link Escape code (for byte stuffing)

#define  NET_TOUT_RCV      (mS(2000))  // ⠩  ਩

   // net.stio
#define  NET_ST_OK            0x00     // ।   ଠ쭮
#define  NET_ST_TOUT          0x01     //   ⠩
#define  NET_ST_CMDERR        0x02     //     (CRC, adr)
#define  NET_ST_DATERR        0x04     //     (CRC)
#define  NET_ST_BREAK         0x08     // ਢ ਩  (਩ ᭨ )
   // net.stcmd
#define  NET_ST_UNKNOWN       0x10     //  
#define  NET_ST_EXEERR        0x20     //    (ࠢ ࠬ, ...)
#define  NET_ST_BSY           0x80     //  ।   祭


   //  
#define  NET_CMD_NULL         0     // ஦ 
#define  NET_CMD_STAT         1     //   
#define  NET_CMD_WR           2     //    slave  (master -> slave)
#define  NET_CMD_RD           3     // ⠭   slave (master <- slave)
#define  NET_CMD_END          4     //  襭 
#define  NET_CMD_CONS         5     // ࠭  筨 ⠭ ᮫ (sl_con_t)
#define  NET_CMD_KEYB         6     //  ᨬ   
#define  NET_CMD_LCDOFF       7     //   ४

#define  NET_CMD_GETCFG       8     // ਬ ࠬ ;

   // 祭 ࠬ  NET_CMD_GETCFG
#define  SL_CFG_INFO          0     // : ଠ (sl_info_t)
#define  SL_CFG_TEM           1     // :  ⥬ (sl_temcfg_t)
#define  SL_CFG_PRESS         2     // :   (sl_presscfg_t)
#define  SL_CFG_TH            3     // : 宬筨  (sl_thcfg_t)
#define  SL_CFG_PAUSE         4     // : 㧠 (sl_pausecfg_t)
#define  SL_CFG_SYS           5     // : ⥬ ࠬ (sl_syscfg_t)
#define  SL_CFG_SIO           6     // : 䥩 (sl_siocfg_t)
#define  SL_CFG_OUT           7     // : 室 (sl_outcfg_t)
#define  SL_CFG_CST           8     // ⠭ (sl_cst_t)
#define  SL_CFG_DTJ           9     // ࠬ 室  /  (sl_dtj_t)

#define  NET_CMD_CURRENT      9     // ਬ 筥 祭 ࠬ (sl_curr_t)

#define  NET_CMD_QUEUE        10    // ਬ 筥 祭   
                                    //   (sl_queue_t)

   //  ਬ    (NET_CMD_HIST*)   (NET_CMD_LOG*);
   // ࠬ஬    : 0 - ⠭ , 1 - ।⠭, ...
#define  NET_CMD_HISTM        11    // ਬ     墨  (gaz_t)
#define  NET_CMD_HISTH        12    // ਬ       (gaz_t)
#define  NET_CMD_HISTD        13    // ਬ       (gaz_t)
#define  NET_CMD_HISTMN       14    // ਬ     筨  (gaz_t)
#define  NET_CMD_LOGEV        15    // ਬ      (evtlog_t)
#define  NET_CMD_LOGCH        16    // ਬ      (chglog_t)


/////////////////////////////////////////////////////////////////


#define  CON_ROWS             2        // rows number of LCD screen
#define  CON_COLS             16       // columns number of LCD screen

   // ० ᮫
#define  CON_MODE_NORMAL      0
#define  CON_MODE_IDLE        1
#define  CON_MODE_SHUTDOWN    2

   //   ᮫
#define  CON_ST_BLINK         0x01     // blink on/off
#define  CON_ST_CURSEN        0x02     // cursor on/off
#define  CON_ST_LCDPOW        0x04     // LCD power on/off
#define  CON_ST_INTEN         0x08     // interrupt enable/disable
#define  CON_ST_IRQ           0x10     // interrupt request 䫠
#define  CON_ST_ASCII         0x20     // ascii on/off
#define  CON_ST_SCROLL        0x40     // scroll on/off
#define  CON_ST_TTY           0x80     // TTY mode on/off


/////////////////////////////////////////////////////////////////


   // slave keyboard scan codes
#define  KEY_NULL    0
#define  KEY_1       1
#define  KEY_2       2
#define  KEY_3       3
#define  KEY_4       4
#define  KEY_5       5
#define  KEY_6       6

#define  KEY_FBASE   8
#define  KEY_F1      (KEY_1+KEY_FBASE)
#define  KEY_F2      (KEY_2+KEY_FBASE)
#define  KEY_F3      (KEY_3+KEY_FBASE)
#define  KEY_F4      (KEY_4+KEY_FBASE)
#define  KEY_F5      (KEY_5+KEY_FBASE)
#define  KEY_F6      (KEY_6+KEY_FBASE)

#define  KEY_OBASE   16
#define  KEY_O1      (KEY_1+KEY_OBASE)

#define  KEY_O2      (KEY_2+KEY_OBASE)
#define  KEY_O3      (KEY_3+KEY_OBASE)
#define  KEY_O4      (KEY_4+KEY_OBASE)
#define  KEY_O5      (KEY_5+KEY_OBASE)
#define  KEY_O6      (KEY_6+KEY_OBASE)

#define  KEY_EBASE   24
#define  KEY_E1      (KEY_1+KEY_EBASE)
#define  KEY_E2      (KEY_2+KEY_EBASE)
#define  KEY_E3      (KEY_3+KEY_EBASE)
#define  KEY_E4      (KEY_4+KEY_EBASE)
#define  KEY_E5      (KEY_5+KEY_EBASE)
#define  KEY_E6      (KEY_6+KEY_EBASE)

#define  KEY_DUMMY   31

   // keys status bitmap
#define  KEY1_BIT    0x01
#define  KEY2_BIT    0x02
#define  KEY3_BIT    0x04
#define  KEY4_BIT    0x08
#define  KEY5_BIT    0x10
#define  KEY6_BIT    0x20

#define  SL_ESC      KEY_1
#define  SL_LEFT     KEY_2
#define  SL_RIGHT    KEY_3
#define  SL_CR       KEY_4
#define  SL_CYCL     KEY_5
#define  KEY_F       SL_CR
#define  KEY_O       SL_CYCL
#define  KEY_E       SL_ESC
#define  KEY_F_BIT   KEY4_BIT
#define  KEY_O_BIT   KEY5_BIT
#define  KEY_E_BIT   KEY1_BIT
#define  SL_BACKSPACE   KEY_FBASE
#define  SL_BS       SL_BACKSPACE

#define  F_AR        (KEY_FBASE+SL_RIGHT)
#define  F_AL        (KEY_FBASE+SL_LEFT)
#define  F_CYCL      (KEY_FBASE+SL_CYCL)
#define  F_ESC       (KEY_FBASE+SL_ESC)

#define  O_AR        (KEY_OBASE+SL_RIGHT)
#define  O_AL        (KEY_OBASE+SL_LEFT)
#define  O_CR        (KEY_OBASE+SL_CR)
#define  O_ESC       (KEY_OBASE+SL_ESC)

#define  E_AR        (KEY_EBASE+SL_RIGHT)
#define  E_AL        (KEY_EBASE+SL_LEFT)
#define  E_CYCL      (KEY_EBASE+SL_CYCL)
#define  E_CR        (KEY_EBASE+SL_CR)


/////////////////////////////////////////////////////////////////

   // ⨯  ⥬
#define  TEM_RTD_Pt     0
#define  TEM_RTD_Cu     1

#define  TEM_ON         1
#define  TEM_OFF        0


/////////////////////////////////////////////////////////////////

   // ⨯  
#define  PR_SENS_ABS    0     //  ᮫⭮ 
#define  PR_SENS_GAGE   1     //  誮 

#define  PR_ON          1
#define  PR_OFF         0

#define  PR_TSZ_U       8     // .  箪  
#define  PR_TSZ_T       8     // .  箪  ⥬


/////////////////////////////////////////////////////////////////


#define  VOL_TSZ        32    // . ஧ ⠡ 㭪 ⢮७ 


/////////////////////////////////////////////////////////////////


#define  LOG_ESZ           200   // .     
#define  LOG_CSZ           200   // .     
#define  LOG_EBUF_SZ       4     // ஧  ࠬ  
#define  LOG_CBUF_SZ       8     // ஧  ࠬ  

#define  EVT_TEM           0
#define  EVT_PRESS         1
#define  EVT_POW           2
#define  EVT_MFLD          3
#define  EVT_SZ            4

#define  EVT_NORM          0     // ࠬ  
#define  EVT_MIN           1     // ࠬ < .
#define  EVT_MAX           2     // ࠬ > .

   //   
#define  LOG_NULL          0
#define  LOG_PWOFF         1     // 祭  
#define  LOG_PWON          2     // 祭  
#define  LOG_RESET         3     // ᪨ ( 祭 )
#define  LOG_DTDEF         4     // ⥬  ⠭  default
#define  LOG_CFGDEF        5     //  ⠭  default

#define  LOG_TEM_NORM      6     // ⥬  
#define  LOG_TEM_MIN       7     // ⥬ < .
#define  LOG_TEM_MAX       8     // ⥬ > .

#define  LOG_PRESS_NORM    9     //   
#define  LOG_PRESS_MIN     10    //  < .
#define  LOG_PRESS_MAX     11    //  > .

#define  LOG_POW_NORM      12    // 㣠   
#define  LOG_POW_MIN       13    // 㣠  < .
#define  LOG_POW_MAX       14    // 㣠  > .

#define  LOG_MFLD_NORM     15    //  ⭥  
#define  LOG_MFLD_MAX      16    //  ⭥  > .

#define  LOG_SUMMER_TIME   17    //    
#define  LOG_WINTER_TIME   18    //    

#define  LOG_PAUSE_BEGIN   19    // ⮪ 㧨
#define  LOG_PAUSE_END     20    // 祭 㧨
#define  LOG_PAUSE_AUTOADD 21    // ⮤  쭮 '


   //   
#define  CHG_NULL          0
#define  CHG_INFO          1     // 쭠 ଠ

#define  CHG_TEM_TYPE      2     // ⨯ RTD
#define  CHG_TEM_R0        3     //  RTD  0'C
#define  CHG_TEM_ONOFF     4     // 祭 RTD
#define  CHG_TEM_DEF       5     // ⥬  㢠
#define  CHG_TEM_MIN       6     // 쭠  ⥬
#define  CHG_TEM_MAX       7     // ᨬ쭠  ⥬
#define  CHG_TEM_PSEN      8     //  ⥬  : on/off

#define  CHG_PR_TYPE       9     // ⨯  : abs | gage
#define  CHG_PR_VEX        10    // ᯮ⭠ 㣠  
#define  CHG_PR_MVV        11    // reserved
#define  CHG_PR_ONOFF      12    // 祭  
#define  CHG_PR_DEF        13    //   㢠
#define  CHG_PR_MIN        14    // 쭠  
#define  CHG_PR_MAX        15    // ᨬ쭠  

#define  CHG_SYS_MEASURE   16    //  
#define  CHG_SYS_CONS      17    // consol timeout: on/off
#define  CHG_SYS_TOUT      18    // consol timeout: sec
#define  CHG_SYS_PWMIN     19    // 쭠 㣠 
#define  CHG_SYS_PWMAX     20    // ᨬ쭠 㣠 

#define  CHG_PZ_MAX        21    // . ਢ 㧨
#define  CHG_PZ_AUTOADD    22    // ⮬筥 

#define  CHG_VOL_FUNC      23    // 㭪 ⢮७ 
#define  CHG_PR_FUNC       24    // 㭪 ⢮७  

#define  CHG_ACCESS        25    //  
#define  CHG_PWD_OPER      26    // ஫ 
#define  CHG_PWD_ADMIN     27    // ஫ 
#define  CHG_PWD_OWNER     28    // ஫ ᭨

#define  CHG_DENSITY       29    // ⨭  ଠ쭨 㬮
#define  CHG_CO2           30    // 業 㣫᫮   
#define  CHG_NITROGEN      31    // 業   
#define  CHG_PBAR          32    // ஬筨 

#define  CHG_DTIME         33    // /  RTC
#define  CHG_SUMMER_JUMP   34    // / 室   
#define  CHG_WINTER_JUMP   35    // / 室   

#define  CHG_PZ_ADDVOL     36    //  '    쭮 '

#define  CHG_CLR_VOLUME    37    // 㫥 筨 ' V  Vn

#define  CHG_CALIBR_T1P    38    // 窮 ஢  ⥬
#define  CHG_CALIBR_T2P    39    // 窮 ஢  ⥬
#define  CHG_CALIBR_P1P    40    // 窮 ஢  
#define  CHG_CALIBR_P2P    41    // 窮 ஢  
#define  CHG_CALIBR_R      42    // ஢  ⥬:  窨 R1,R2
#define  CHG_CALIBR_U      43    // ஢  :  窨 U1,U2

#define  CHG_COUNTER       44    // 稫쭨 

#define  CHG_DEFPWD        45    // ஫  㢠

#define  CHG_SIO_ONOFF     46    // 䥩 on/off
#define  CHG_SIO_BAUD      47    // 袨 䥩
#define  CHG_SIO_ADR       48    // ०  䥩

#define  CHG_PULSE_WIDTH   49    // 쭠 ਢ   室
#define  CHG_OUT1_MODE     50    // 1: ० ࠡ
#define  CHG_OUT2_MODE     51    // 2: ० ࠡ
#define  CHG_OUT1_VOL      52    // 1:     '
#define  CHG_OUT2_VOL      53    // 2:     '

#define  CHG_SYS_H0        54    //    




/*---- type ---------------------------------------------------*/

typedef  signed   char  schar;
typedef  unsigned char  uchar;
typedef  unsigned short ushort;
typedef  unsigned int   uint;
typedef  unsigned long  ulong;

typedef
struct {
   ulong it;      //  ⨭ ᫠
   float fr;      // ஡ ⨭ ᫠
   }
ulongfloat;


/////////////////////////////////////////////////////////////////


#pragma  ZTC align 1

typedef
struct {
   short n;          // ࠧ ⠡
   uchar xlim;       // =1:  㬥,   室  

   //int *x;           // ᨢ 祭 㬥
   uchar xm;         // ⨯ '
   ushort xa;        // 

   //int *f;           // ᨢ 祭 㭪
   uchar fm;         // ⨯ '
   ushort fa;        // 

   float scale;      // ⠡稩 
   }
table_t;


typedef
struct {
   short nx;         // ஧ ⠡  
   uchar xlim;       // =1:  x

   //int *x;           // ᨢ 祭 㬥 x
   uchar xm;         // ⨯ '
   ushort xa;        // 

   //table_t *f;       // ᨢ ⠡ ୨ 㭪 z=f(y), (
                       //   ᨢ 㬥 x ᢮ 㭪 f)
   uchar fm;         // ⨯ '
   ushort fa;        // 

   float scale;      // ⠡稩 
   }
table2_t;


typedef
struct {
   uchar hs;         // hundredths of a second,  0..99
   uchar s;          // seconds,  0..59
   uchar m;          // minutes,  0..59
   uchar h;          // hours,    0..23
   uchar d;          // day,      1..31
   uchar mn;         // month,    1..12
   ushort y;         // year,     19xx..2xxx
   uchar w;          // weekday,  0..6;  0: sunday
   }
dtime_t;


typedef
struct {
   ushort i;         /* 筨  */
   ushort q;         /* pp p (   p) */
   ushort n;         /* pp p ( ) */
   ushort sz;        /* pp  () */
   //void *bf;         /* ->  p */
   uchar bfm;        // ⨯ '
   ushort bfa;       // 
   }
xque_t;


typedef
struct {
   float gC;         // ⥬ , 'C
   float gK;         // ⥬ , 'K
   float pC;         // ⥬  , 'C
   short R;          // ﭨ  RTD, R(Ohm)*100
   }
tem_t;


typedef
struct {
   float gaz;        //   (᮫⭨), MPa;
   short U;          // ﭠ 㣠 ⪠, mV;
   float vsc;        // ⠡稩 , 直 ਢ 
                     // .  ⪠   ᯮ⭨ 祭
   }
press_t;


typedef
struct {
   uchar f;          // ࠯  ⠭ 稫쭨 
   ulong cnt;        // 筥 祭 稫쭨  宬
   dtime_t t1;       // / 室 ।쮣 
   dtime_t t2;       // / 室 ⠭쮣 
   ulong hs;         //  室  (⠭. .), hsec
   ulong xhs;        // 㬠  ,  諨  
                     //  横 ᫥, hsec
   }
thcnt_t;


typedef
struct {
   float dV;         // 筨  ', 3
   float dVn;        // 筨  '  ଠ쭨 㬮, 3
   float Q;          // 筨 ஧, 3/
   float Qn;         // 筨 ஧  ଠ쭨 㬮, 3/
   }
volume_t;


typedef
struct {
   dtime_t dt;       // , 
   float   tem;      // । ⥬, 'C
   float   pr;       // ।  (᮫⭨), MPa
   float   Q;        // । ஧, 3/
   float   Qn;       // । ஧  ଠ쭨 㬮, 3/
   ulongfloat  V;    // ', 3
   ulongfloat  Vn;   // '  ଠ쭨 㬮, 3
   }
gaz_t;


typedef
struct {
   dtime_t dt[2];    // /    㧨
   ulong   hs;       // ਢ 㧨, hsec
   float   Q;        // । ஧   㧨, 3/
   float   Qn;       // । ஧  ଠ쭨 㬮, 3/
   float   dV;       // '   ⠭ 㧨, 3
   float   dVn;      // '   ⠭ 㧨  .㬮, 3
   ulongfloat  V;    // 㬠୨ '  쪠 , 3
   ulongfloat  Vn;   // 㬠୨ '  쪠   .㬮, 3
   }
pause_t;


typedef
struct {
   float Pkr;        // ᥢ筨 , /2
   float Tkr;        // ᥢ筠 ⥬, 'K
   float Pc;         // ਢ 
   float Tc;         // ਢ ⥬
   float Z;          //  㢠 
   float K;          //  ४
   }
corr_t;


typedef
struct {
   ushort vpow;      // 㣠  , mV
   uchar mfld;       // ⠭  쮣 ⭮ :
                     // 0 -  ;  1: -  ;
   }
sys_t;


typedef
struct {
   uchar   st;       // 筨 ⠭ "": 0 - ଠ
   uchar   id;       //    
   dtime_t dt;       // /  
   }
event_t;


typedef
struct {
   dtime_t dt;       // / 
   uchar   id;       //  
   uchar   bf[LOG_EBUF_SZ];   //  ࠬ 
   }
evtlog_t;


typedef
struct {
   dtime_t dt;       // / 
   uchar   id;       //  
   uchar   bf[LOG_CBUF_SZ];   //  ࠬ 
   }
chglog_t;


/////////////////////////////////////////////////////////////////

   // slave: ⠭ ᮫   ࠭;   NET_CMD_CONS
typedef
struct {
   uchar mode;       // ० ஡ ᮫: CON_MODE_*
   uchar tmc;        // 稫쭨 ⠩ ᮫, (cn_tm0..0), sec
   uchar edf;        // ࠯ ० ।㢠 窨

      // 㯭 ࠬ  쪨   mode == CON_MODE_NORMAL
   uchar st;         //   ᮫: CON_ST_*
   uchar adr;        // 筨   LCD
   uchar crow;       // 筠  : 窠 (0...CON_ROWS-1)
   uchar ccol;       // 筠  : ⮢ (0...CON_COLS-1)
   uchar scr[CON_ROWS*CON_COLS];    //  ࠭ (!!! lcd charset)
   }
sl_con_t;


   // slave: ଠ;  NET_CMD_INFO
typedef
struct {
   uchar s[6][20];   // 6 ᨬ쭨 箪: ଠ 猪  㢠祬
   uchar fw[6][20];  // 6 箪: 0,1- ਫ; 2,3- firmware;
                     // 4,5-/ ;
   ushort sernum;    //   ਫ
   }
sl_info_t;

   // slave:   ⥬;  NET_CMD_TEMCFG
typedef
struct {
   uchar type;       // ⨯ : TEM_RTD_*
   short R0;         //  RTD  0'C, R(Ohm)*100;
   uchar on;         // ࠯ 祭 : 1-祭;
                     //    0- 祭 (. . def);
   float def;        // 祭 ⥬  㢠
   float mn;         // ࠭筥 祭  alarm: min
   float mx;         // ࠭筥 祭  alarm: 
   uchar ps_on;      // ࠯  ⥬  ;
                     // 0 -  祭; 1 - 祭;
   short CfA[2];     //  ⠡ ।筮 㭪 
   short CfB[2];     //  R*100 = F(adc);
   float CfK[2];     // y = (CfK[0] * x) + CfK[1];
   }
sl_temcfg_t;


   // slave:   ;  NET_CMD_PRESSCFG
typedef
struct {
   uchar type;       // ⨯ : PR_SENS_*
   uchar on;         // ࠯ 祭 : 1-祭;
                     //    0- 祭 (. . pr.def);
   float def;        // 祭   㢠, MPa;
   float mn;         // ࠭筥 祭  alarm: min, MPa
   float mx;         // ࠭筥 祭  alarm: , MPa
   float vex;        // 㣠   (ᯮ⭠), mV;
   float mvv;        // reserved

      //  ⠡ ।筮 㭪   U(mV)*100 = F(adc);
   short CfA[2];     //
   short CfB[2];     //
   float CfK[2];     //

      // ⠡ 㭪 ⢮७  , P = F(u,t);
   short Tt[PR_TSZ_T];           // ⥬, 'C
   short Tu[PR_TSZ_T][PR_TSZ_U]; // 㣠, mV*100
   short Tp[PR_TSZ_T][PR_TSZ_U]; // , MPa*1000
   table_t pFu[PR_TSZ_T];
   table2_t F;
   }
sl_presscfg_t;

   // slave:  宬筮 ;  NET_CMD_THCFG
typedef
struct {
   float   vn;       // ' (3),  类  ࠪ⨪
                     // ; '/(1 .): dV1 = th.vn / Ni;
   short T[VOL_TSZ]; //   ᠬ , 1==10msec
   short N[VOL_TSZ]; //    ' th.vn
   table_t Ftbl;     // ⠡ 㭪 ⢮७ 
   }
sl_thcfg_t;


   // slave:  㧨;  NET_CMD_PAUSECFG
typedef
struct {
   ulong mx;         // . ਢ 祭 , 1 == 0.01 
   uchar ae;         // ࠯  ⮬筮 
                     //  쭮 '  
   }
sl_pausecfg_t;


   // slave: ⥬ ⠭;  NET_CMD_SYSCFG
typedef
struct {
   uchar mtu;        //  (sec)   ।
   float mtf;        //  (sec)   ।
   uchar ut0;        // timeout ⨢ 㢠, sec
   uchar uton;       // ࠯  timeout- 㢠
   uchar contrast;   //  LCD
   ushort vpwmn;     // 쭠 㣠 , mV
   ushort vpwmx;     // ᨬ쭠 㣠 , mV
   uchar apw;        // ࠯   :
                     // 0: ᭨ ०;  1: 祭 ;

      // firmware >= v2.6
   uchar h0;         //    , : 0..23
   }
sl_syscfg_t;


   // slave:  䥩;  NET_CMD_SIOCFG
typedef
struct {
   uchar en;         // ࠯  ஡ 䥩
   uchar baud;       // 袨: SIO_BAUD_*
   uchar adr;        // ०  ਫ: 1...126
   }
sl_siocfg_t;


   // slave:   ;  NET_CMD_OUTCFG
typedef
struct {
   uchar ms;         // ਢ , ᥪ (5..70)
   ushort tms;       // ਢ , tmS(x)
   uchar mode[2];    // ० ஡ : OUT_*
   float v1[2];      //     OUT_VOL*, 3
   }
sl_outcfg_t;


   // slave: 祭 ⠭;  NET_CMD_CST
typedef
struct {
   float    Dn;      // ⨭   . 㬮, /3
   float    aCO2;    // 業 㣫᫮   , %
   float    aN2;     // 業   , %
   float    Pbar;    // ஬筨 , MPa;
   }
sl_cst_t;


   // slave: ࠬ 室  / ;  NET_CMD_DTJ
typedef
struct {
   uchar mn;         // month,   0,1..12  (0 -  ஭)
   uchar wn;         // weeknum of month, 1..5  (5  ⠭ )
   uchar wd;         // weekday, 0..6
   uchar h;          // hour,    0..23
   }
dtjump_t;

typedef
struct {
   dtjump_t s;       // / 室   
   dtjump_t w;       // / 室   
   }
sl_dtj_t;


   // slave: 筥 祭 ࠬ;  NET_CMD_CURRENT
typedef
struct {
   dtime_t  dt;      // /
   tem_t    tm;      // ⥬
   press_t  pr;      // 
   thcnt_t  th;      // 稫쭨 
   volume_t vl;      //  '
   gaz_t    gz;      // ⥬, , , '
   pause_t  pz;      // 㧠
   corr_t   cr;      // . 㢠  ४
   sys_t    sys;     // 㣠 , .
   event_t  evt[EVT_SZ];   // 
   }
sl_curr_t;


   // slave: 筨 ⠭    ;   NET_CMD_QUEUE
typedef
struct {
   xque_t   hm;      // ࣠  墨 
   xque_t   hh;      // ࣠   
   xque_t   hd;      // ࣠   
   xque_t   hmn;     // ࣠  筨 
   xque_t   le;      // ࣠  
   xque_t   lc;      // ࣢  
   }
sl_queue_t;


#pragma  ZTC align



/*---- macros -------------------------------------------------*/

#ifndef  Size
#define  Size(x,y)      (sizeof(x)/sizeof(y))
#endif

#ifndef  min
#define  min(a,b)       (((a) < (b)) ? (a) : (b))
#endif

#define  Hi(x)          ((uchar)(((uint)(x))>>8))
#define  Lo(x)          ((uchar)(x))
#define  HiWord(x)      ((uint)(((ulong)(x))>>16))
#define  LoWord(x)      ((uint)(x))


/////////////////////////////////////////////////////////////////


#define  crc_init()     (crc = 0)
#define  crc_add(c)     (crc = (crc << 8) ^ crctabl[ Hi(crc) ^ (c) ])


/////////////////////////////////////////////////////////////////


#define  net_tx_en()             (sio_rts(net.port, 1))
#define  net_tx_dis()            (sio_rts(net.port, 0))

#define  net_endses(adr)         (net_cmd((adr), NET_CMD_END, 0))
#define  net_lcdoff(adr)         (net_cmd((adr), NET_CMD_LCDOFF, 0))
#define  net_updqueue(adr)       (net_cmd((adr), NET_CMD_QUEUE, 0))


/////////////////////////////////////////////////////////////////


   // delay(uS(x)) | delay(mS(x))
#define  uS(x)    ((ulong)(x))
#define  mS(x)    (((ulong)(x))*1000L)


/////////////////////////////////////////////////////////////////
